## mpg123 1.25.0

=== debian/changelog ===
mpg123 (1.25.0-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * New upstream release.
    - Fix crashes in Remote mode if FORMAT command issued. (Closes: #862753)
  * debian/libmpg123-0.symbols.common.in: Add new symbol.
  * debian/control: Remove unnecessary B-D on python-minimal. (Closes:
    #856565)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 18 Jun 2017 11:48:56 +0200

mpg123 (1.24.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/copyright: Update copyright years.
  * debian/{rules,compat,control}: Bump debhelper compat to 10.
  * debian/rules: Simplify flags handling.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 25 Apr 2017 21:46:03 +0200

=== debian/control ===
Source: mpg123
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Reinhard Tartler <siretart@tauware.de>,
 Miguel A. Colón Vélez <debian.micove@gmail.com>
Build-Depends:
 debhelper (>= 10),
 libasound2-dev [linux-any],
 libaudio-dev,
 libjack-dev,
 libltdl-dev,
 libopenal-dev,
 libpulse-dev [!hurd-i386],
 pkg-config,
 portaudio19-dev
Standards-Version: 3.9.8
Homepage: http://mpg123.org/
Vcs-Git: https://anonscm.debian.org/cgit/pkg-multimedia/mpg123.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/mpg123.git

Package: mpg123
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 alsa-utils [linux-any],
 jackd,
 nas,
 oss-compat [linux-any],
 oss4-base [linux-any],
 pulseaudio
Provides:
 mpg123-oss-3dnow
Replaces:
 mpg123-alsa,
 mpg123-esd,
 mpg123-nas,
 mpg123-oss-3dnow,
 mpg123-oss-i486
Description: MPEG layer 1/2/3 audio player
 mpg123 is a real time MPEG 1.0/2.0/2.5 audio player/decoder for layers
 1, 2 and 3 (MPEG 1.0 layer 3 also known as MP3).
 .
 This package contains output plugins for several audio systems, including
 OSS4, the Advanced Linux Sound Architecture (ALSA), JACK, PortAudio,
 PulseAudio, OpenAL and the Network Audio System (NAS).

Package: libmpg123-0
Multi-Arch: same
Architecture: any
Section: libs
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: MPEG layer 1/2/3 audio decoder (shared library)
 mpg123 is a real time MPEG 1.0/2.0/2.5 audio player/decoder for layers
 1, 2 and 3 (MPEG 1.0 layer 3 also known as MP3).
 .
 This package contains the C libraries needed to run executables that use
 the mpg123 library.

Package: libout123-0
Multi-Arch: same
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: MPEG layer 1/2/3 audio decoder (libout123 shared library)
 mpg123 is a real time MPEG 1.0/2.0/2.5 audio player/decoder for layers
 1, 2 and 3 (MPEG 1.0 layer 3 also known as MP3).
 .
 This package contains the shared out123 library.

Package: libmpg123-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends:
 libmpg123-0 (= ${binary:Version}),
 libout123-0 (= ${binary:Version}),
 ${misc:Depends}
Description: MPEG layer 1/2/3 audio decoder (development files)
 mpg123 is a real time MPEG 1.0/2.0/2.5 audio player/decoder for layers
 1, 2 and 3 (MPEG 1.0 layer 3 also known as MP3).
 .
 This package contains the C development headers and library files needed
 to compile programs using the mpg123 library.

## mpg123 1.25.3

=== debian/changelog ===
mpg123 (1.25.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - Fix buffer over-read via crafted audio files. (CVE-2017-11126)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 23 Jul 2017 16:03:48 +0200

mpg123 (1.25.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - Fix heap-based buffer over-read (CVE-2017-10683) (Closes: #866860)
  * debian/control: Bump Standards-Version.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 03 Jul 2017 21:13:06 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  libpulse-dev [!hurd-i386],
  pkg-config,
  portaudio19-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://mpg123.org/
 Vcs-Git: https://anonscm.debian.org/cgit/pkg-multimedia/mpg123.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/mpg123.git

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.sig/ http://sf.net/mpg123/mpg123-(.*)\.tar.bz2

## mpg123 1.25.4

=== debian/changelog ===
mpg123 (1.25.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - Fix buffer over-read. (CVE-2017-9545) (Closes: #870799)
  * debian/control: Bump Standards-Version.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 06 Aug 2017 14:33:07 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  libpulse-dev [!hurd-i386],
  pkg-config,
  portaudio19-dev
-Standards-Version: 4.0.0
+Standards-Version: 4.1.0
 Homepage: http://mpg123.org/
 Vcs-Git: https://anonscm.debian.org/cgit/pkg-multimedia/mpg123.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/mpg123.git

## mpg123 1.25.6

=== debian/changelog ===
mpg123 (1.25.6-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control: Fix Standards-Version.

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 12 Aug 2017 11:53:27 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  libpulse-dev [!hurd-i386],
  pkg-config,
  portaudio19-dev
-Standards-Version: 4.1.0
+Standards-Version: 4.0.1
 Homepage: http://mpg123.org/
 Vcs-Git: https://anonscm.debian.org/cgit/pkg-multimedia/mpg123.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/mpg123.git

## mpg123 1.25.10

=== debian/changelog ===
mpg123 (1.25.10-1) unstable; urgency=medium

  * Team upload.

  [ Sebastian Ramacher ]
  * debian/control: Drop obsolete Pre-Depends.
  * New upstream release.

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 10 Mar 2018 11:02:34 +0100

mpg123 (1.25.8-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control: Bump Standards-Version.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 03 Dec 2017 21:31:49 +0100

mpg123 (1.25.7-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - Do not play with cursor and inverse video for progress bar when
      TERM=dumb. (Closes: #872362)
    - Fix parsing of host port for numerical IPv6 addresses. (Closes: #872361)
  * debian/control: Bump Standards-Version.
  * debian/mpg123.manpages: Removed, not needed.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 26 Sep 2017 16:12:35 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Reinhard Tartler <siretart@tauware.de>,
  Miguel A. Colón Vélez <debian.micove@gmail.com>
 Build-Depends:
- debhelper (>= 10),
+ debhelper (>= 11),
  libasound2-dev [linux-any],
  libaudio-dev,
  libjack-dev,
@@ -15,10 +15,10 @@
  libpulse-dev [!hurd-i386],
  pkg-config,
  portaudio19-dev
-Standards-Version: 4.0.1
+Standards-Version: 4.1.3
 Homepage: http://mpg123.org/
-Vcs-Git: https://anonscm.debian.org/cgit/pkg-multimedia/mpg123.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/mpg123.git
+Vcs-Git: https://salsa.debian.org/multimedia-team/mpg123.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/mpg123
 
 Package: mpg123
 Architecture: any
@@ -52,8 +52,6 @@
 Multi-Arch: same
 Architecture: any
 Section: libs
-Pre-Depends:
- ${misc:Pre-Depends}
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

ARCH:=$(DEB_HOST_ARCH)
OS:=$(DEB_HOST_ARCH_OS)
CPU:=$(DEB_HOST_ARCH_CPU)

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

WRAPPER_TARGETS:=mpg123-oss mpg123-nas mpg123-jack mpg123-openal mpg123-portaudio
ifeq ($(OS),linux)
	WRAPPER_TARGETS += mpg123-alsa
endif
ifneq ($(OS),hurd)
	WRAPPER_TARGETS += mpg123-pulse
endif

CONF_COMMON:=--enable-static=no --enable-shared --enable-lfs-alias \
	--with-module-suffix=.so

CONF_i386:=--with-cpu=x86_dither
CONF_arm:=--with-cpu=generic_fpu

mpg123-%: debian/mpg123-wrapper.in
	dh_testdir
	o=`echo $@ | sed -e 's/^mpg123-\([^-]\+\).*/\1/'`; \
	sed -e "s/@OUTPUT@/$$o/g" < debian/mpg123-wrapper.in > $@

override_dh_autoreconf:
	dh_autoreconf --as-needed

override_dh_auto_configure:
	dh_auto_configure -- $(CONF_COMMON) $(CONF_$(CPU))

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(WRAPPER_TARGETS)

override_dh_auto_install: $(WRAPPER_TARGETS)
	dh_auto_install

	mv $(CURDIR)/debian/tmp/usr/bin/mpg123 \
	   $(CURDIR)/debian/tmp/usr/bin/mpg123.bin
	mv $(CURDIR)/debian/tmp/usr/share/man/man1/mpg123.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/mpg123.bin.1
	install $(WRAPPER_TARGETS) $(CURDIR)/debian/tmp/usr/bin/
	for i in $(WRAPPER_TARGETS); do \
		install debian/mpg123-wrapper.1 \
		        $(CURDIR)/debian/tmp/usr/share/man/man1/$$i.1; \
	done

override_dh_installchangelogs:
	dh_installchangelogs -pmpg123 NEWS
	dh_installchangelogs -plibmpg123-dev NEWS.libmpg123
	dh_installchangelogs --remaining-packages

%:
	dh $@

## mpg123 1.25.12

=== debian/changelog ===
mpg123 (1.25.12-1build1) eoan; urgency=medium

  * No-change upload with strops.h and sys/strops.h removed in glibc.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Sep 2019 11:02:50 +0000

mpg123 (1.25.12-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 27 Aug 2019 22:21:00 +0200

mpg123 (1.25.11-1) unstable; urgency=medium

  * Team upload.

  [ Ondřej Nový ]
  * d/watch: Use https protocol
  * Use debhelper-compat instead of debian/compat

  [ Sebastian Ramacher ]
  * New upstream release. (Closes: #934613)
  * debian/control:
    - Bump debhelper compat to 12.
    - Bump Standards-Version.
  * debian/libmpg123-0.lintian-overrides: Use architecture-specific overrides.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 18 Aug 2019 21:24:10 +0200

mpg123 (1.25.10-2) unstable; urgency=medium

  * Team upload.

  [ James Cowgill ]
  * debian/control: Bump standards to 4.1.4.
  * debian/libmpg123-0.symbols:
    - Use more intelligent way of enabling 32-bit off_t symbols.
      Fixes FTBFS on riscv64. (Closes: #896126)

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

 -- James Cowgill <jcowgill@debian.org>  Fri, 20 Apr 2018 10:44:09 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: mpg123
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Reinhard Tartler <siretart@tauware.de>,
  Miguel A. Colón Vélez <debian.micove@gmail.com>
 Build-Depends:
- debhelper (>= 11),
+ debhelper-compat (= 12),
+ dpkg-dev (>= 1.18),
  libasound2-dev [linux-any],
  libaudio-dev,
  libjack-dev,
@@ -15,7 +16,7 @@
  libpulse-dev [!hurd-i386],
  pkg-config,
  portaudio19-dev
-Standards-Version: 4.1.3
+Standards-Version: 4.4.0
 Homepage: http://mpg123.org/
 Vcs-Git: https://salsa.debian.org/multimedia-team/mpg123.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/mpg123

## mpg123 1.25.13

=== doc/examples/Makefile ===
targets = \
  mpg123_test \
  feedseek \
  mpg123_to_out123 \
  mpg123_to_wav_replaced_io \
  scan \
  id3dump \
  mpglib \
  dump_seekindex \
  extract_frames

all: $(targets)

# On largefile-aware systems you might want to use these instead:
#MPG123_CFLAGS  := $(shell pkg-config --cflags libmpg123_64)
#MPG123_LDFLAGS := $(shell pkg-config --libs   libmpg123_64)
# This works on sane setups where off_t is off_t, and just that.
ifeq ($(MPG123_PREFIX),)
  MPG123_CFLAGS  := $(shell pkg-config --cflags libmpg123)
  MPG123_LDFLAGS := $(shell pkg-config --libs   libmpg123)
  OUT123_CFLAGS  := $(shell pkg-config --cflags libout123)
  OUT123_LDFLAGS := $(shell pkg-config --libs   libout123)
else # Yeah, that's with GNU/Linux in mind, at least GNU ld ...
  MPG123_CFLAGS  := -I$(MPG123_PREFIX)/include
  MPG123_LDFLAGS := -L$(MPG123_PREFIX)/lib -Wl,-rpath $(MPG123_PREFIX)/lib -lmpg123
  OUT123_CFLAGS  := -I$(MPG123_PREFIX)/include
  OUT123_LDFLAGS := -L$(MPG123_PREFIX)/lib -Wl,-rpath $(MPG123_PREFIX)/lib -lout123
endif

# Oder of libs not that important here...
compile = $(CC) $(CPPFLAGS) $(CFLAGS) $(MPG123_CFLAGS)
linkflags = $(MPG123_LDFLAGS) $(LDFLAGS)

mpg123_to_out123: mpg123_to_out123.c
	$(compile) -o $@ $< $(OUT123_CFLAGS) $(OUT123_LDFLAGS) $(linkflags)

mpg123_to_wav_replaced_io: mpg123_to_wav_replaced_io.c
	$(compile) -o $@ $< $(OUT123_CFLAGS) $(OUT123_LDFLAGS) $(linkflags)

feedseek: feedseek.c
	$(compile) -o feedseek feedseek.c $(linkflags)

scan: scan.c
	$(compile) -o scan scan.c $(linkflags)

id3dump:id3dump.c
	$(compile) -o id3dump id3dump.c $(linkflags)

dump_seekindex: dump_seekindex.c
	$(compile) -o dump_seekindex dump_seekindex.c $(linkflags)

mpglib: mpglib.c
	$(compile) -o mpglib mpglib.c $(linkflags)

mpg123_test: mpg123_test.c
	$(compile) -o $@ $< $(linkflags)

extract_frames: extract_frames.c
	$(compile) -o $@ $< $(linkflags)

clean:
	rm -vf $(targets)

=== debian/changelog ===
mpg123 (1.25.13-1ubuntu0.2) focal-security; urgency=medium

  * SECURITY UPDATE: incomplete fix for OOB write (LP: #2089680)
    - debian/patches/CVE-2024-10573-2.patch: safeguard against attempts to
      decode if decoder setup failed and user ignored the returned error
      code in src/libmpg123/format.c, src/libmpg123/frame.h,
      src/libmpg123/libmpg123.c, src/mpg123.c.
    - CVE-2024-10573

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 26 Nov 2024 10:23:12 -0500

mpg123 (1.25.13-1ubuntu0.1) focal-security; urgency=medium

  * SECURITY UPDATE: OOB write during PCM decoding
    - debian/patches/CVE-2024-10573.patch: don't prepare for actual frame
      data when there is none and separate header data into a struct,
      ensure late updating in frame in src/libmpg123/frame.c,
      src/libmpg123/frame.h, src/libmpg123/layer1.c,
      src/libmpg123/layer2.c, src/libmpg123/layer3.c,
      src/libmpg123/libmpg123.c, src/libmpg123/parse.c,
      src/libmpg123/getbits.h.
    - CVE-2024-10573

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 04 Nov 2024 13:49:25 -0500

mpg123 (1.25.13-1) unstable; urgency=medium

  * Team upload

  [ Ondřej Nový ]
  * Bump Standards-Version to 4.4.1

  [ Sebastian Ramacher ]
  * New upstream release
  * debian/control: Set RRR: no

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 17 Nov 2019 16:37:36 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: mpg123
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Reinhard Tartler <siretart@tauware.de>,
  Miguel A. Colón Vélez <debian.micove@gmail.com>
@@ -16,10 +17,11 @@
  libpulse-dev [!hurd-i386],
  pkg-config,
  portaudio19-dev
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: http://mpg123.org/
 Vcs-Git: https://salsa.debian.org/multimedia-team/mpg123.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/mpg123
+Rules-Requires-Root: no
 
 Package: mpg123
 Architecture: any

## mpg123 1.26.3

=== ports/cmake/src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

include(CheckCSourceCompiles)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckSymbolExists)
include(CMakeDependentOption)
include(TestBigEndian)

check_include_file("arpa/inet.h" HAVE_ARPA_INET_H)
check_include_file("dirent.h" HAVE_DIRENT_H)
check_include_file("dlfcn.h" HAVE_DLFCN_H)
check_include_file("inttypes.h" HAVE_INTTYPES_H)
check_include_file("langinfo.h" HAVE_LANGINFO_H)
check_include_file("limits.h" HAVE_LIMITS_H)
check_include_file("locale.h" HAVE_LOCALE_H)
check_include_file("netdb.h" HAVE_NETDB_H)
check_include_file("netinet/in.h" HAVE_NETINET_IN_H)
check_include_file("sched.h" HAVE_SCHED_H)
check_include_file("signal.h" HAVE_SIGNAL_H)
check_include_file("stdio.h" HAVE_STDIO_H)
check_include_file("stdint.h" HAVE_STDINT_H)
check_include_file("stdlib.h" HAVE_STDLIB_H)
check_include_file("string.h" HAVE_STRING_H)
check_include_file("sys/ioctl.h" HAVE_SYS_IOCTL_H)
check_include_file("sys/ipc.h" HAVE_SYS_IPC_H)
check_include_file("sys/param.h" HAVE_SYS_PARAM_H)
check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H)
check_include_file("sys/select.h" HAVE_SYS_SELECT_H)
check_include_file("sys/shm.h" HAVE_SYS_SHM_H)
check_include_file("sys/signal.h" HAVE_SYS_SIGNAL_H)
check_include_file("sys/socket.h" HAVE_SYS_SOCKET_H)
check_include_file("sys/stat.h" HAVE_SYS_STAT_H)
check_include_file("sys/time.h" HAVE_SYS_TIME_H)
check_include_file("sys/types.h" HAVE_SYS_TYPES_H)
check_include_file("sys/wait.h" HAVE_SYS_WAIT_H)
check_include_file("termios.h" HAVE_TERMIOS)
check_include_file("unistd.h" HAVE_UNISTD_H)
check_include_file("windows.h" HAVE_WINDOWS_H)

check_symbol_exists(strerror "string.h" HAVE_STRERROR)

function(check_m)
    set(CMAKE_REQUIRED_LIBRARIES m)
    check_function_exists(sin HAVE_M)
endfunction(check_m)
check_m()

check_function_exists(atoll HAVE_ATOLL)
check_function_exists(getaddrinfo HAVE_IPV6)
check_function_exists(mkfifo HAVE_MKFIFO)
check_function_exists(mmap HAVE_MMAP)
check_function_exists(nl_langinfo HAVE_NL_LANGINFO)
check_function_exists(random HAVE_RANDOM)
check_function_exists(setlocale HAVE_SETLOCALE)
check_function_exists(setpriority HAVE_SETPRIORITY)
check_function_exists(shmget HAVE_SHMGET)
check_function_exists(shmat HAVE_SHMAT)
check_function_exists(shmdt HAVE_SHMDT)
check_function_exists(shmctl HAVE_SHMCTL)

search_libs(gethostbyname GETHOSTBYNAME_LIB nsl socket network)
search_libs(socket SOCKET_LIB socket)

test_big_endian(WORDS_BIGENDIAN)

check_c_source_compiles(
    "int main() { __asm__(\".balign 4\"); return 0; }"
    ASMALIGN_BALIGN)
check_c_source_compiles(
    "int main() { __asm__(\".align 3\"); return 0; }"
    ASMALIGN_EXP)
if(NOT ASMALIGN_EXP)
    set(ASMALIGN_BYTE ON)
endif()

check_c_source_compiles(
    "int main() { __attribute__((aligned(16))) float var; return 0; }"
    CCALIGN)

check_c_source_compiles("
    #include <sys/types.h>
     /* Check that off_t can represent 2**63 - 1 correctly.
        We can't simply define LARGE_OFF_T to be 9223372036854775807,
        since some C++ compilers masquerading as C compilers
        incorrectly reject 9223372036854775807.  */
    #define LARGE_OFF_T (((off_t) 1 << 62) - 1 + ((off_t) 1 << 62))
    int off_t_is_large[
        (LARGE_OFF_T % 2147483629 == 721 && LARGE_OFF_T % 2147483647 == 1) ? 1 : -1];
    int main() { return 0; }"
    LFS_INSENSITIVE)
if(NOT LFS_INSENSITIVE)
    check_c_source_compiles("
        #define _FILE_OFFSET_BITS 64
        #include <sys/types.h>
         /* Check that off_t can represent 2**63 - 1 correctly.
            We can't simply define LARGE_OFF_T to be 9223372036854775807,
            since some C++ compilers masquerading as C compilers
            incorrectly reject 9223372036854775807.  */
        #define LARGE_OFF_T (((off_t) 1 << 62) - 1 + ((off_t) 1 << 62))
        int off_t_is_large[
            (LARGE_OFF_T % 2147483629 == 721 && LARGE_OFF_T % 2147483647 == 1) ? 1 : -1];
        int main() { return 0; }"
        LFS_SENSITIVE)
endif()
check_type_size(long SIZEOF_LONG)
check_type_size(off_t SIZEOF_OFF_T)
if(LFS_SENSITIVE)
    set(LFS_ALIAS_TYPE long)
    math(EXPR LFS_ALIAS_BITS "${SIZEOF_LONG} * 8")
elseif(CMAKE_ANDROID_ARCH_ABI)
    check_type_size(off64_t SIZEOF_OFF64_T)
    set(LFS_ALIAS_TYPE off64_t)
    math(EXPR LFS_ALIAS_BITS "${SIZEOF_OFF64_T} * 8")
else()
    set(LFS_ALIAS_TYPE off_t)
    math(EXPR LFS_ALIAS_BITS "${SIZEOF_OFF_T} * 8")
endif()

if(WIN32 AND HAVE_WINDOWS_H)
    check_c_source_compiles("
        #include <windows.h>

        int main() {
          LoadLibraryW(0);
          GetProcAddress(0, 0);
          FreeLibrary(0);
        }"
        HAVE_WIN_DL)
else()
    function(check_dl)
        set(CMAKE_REQUIRED_LIBRARIES dl)
        check_symbol_exists(dlopen "dlfcn.h" HAVE_UNIX_DL)
    endfunction(check_dl)
    check_dl()
endif()

set(DYNAMIC_BUILD ${BUILD_SHARED_LIBS})
if(MSVC)
    set(STDERR_FILENO "(_fileno(stderr))")
    set(STDIN_FILENO "(_fileno(stdin))")
    set(STDOUT_FILENO "(_fileno(stdout))")
endif()
set(HAVE_WIN32_FIFO ${WIN32})
set(WANT_WIN32_UNICODE ${WIN32})
set(WITH_SEEKTABLE 1000)

if(NOT WITH_SEEKTABLE EQUAL 0)
    set(FRAME_INDEX 1)
endif()

if(WIN32)
    set(HAVE_MKFIFO ON)
endif()

if(HAVE_NETDB_H AND HAVE_SYS_PARAM_H AND HAVE_SYS_SOCKET_H AND HAVE_NETINET_IN_H AND HAVE_ARPA_INET_H)
    set(HAVE_NETWORK ON)
endif()

if(NO_MESSAGES)
    set(NO_WARNING ON)
    set(NO_ERRORMSG ON)
    set(NO_ERETURN ON)
endif()

cmake_host_system_information(RESULT HAVE_FPU QUERY HAS_FPU)

if(NOT HAVE_FPU)
    set(NO_SYNTH32 ON)
endif()

# Modules

if(CHECK_MODULES)
    list(FIND CHECK_MODULES alsa ALSA_REQUIRED)
    list(FIND CHECK_MODULES coreaudio COREAUDIO_REQUIRED)
    list(FIND CHECK_MODULES pulse PULSE_REQUIRED)
    list(FIND CHECK_MODULES win32 WIN32_REQUIRED)
    list(FIND CHECK_MODULES win32_wasapi WIN32_WASAPI_REQUIRED)
    set(MODULE_NOT_FOUND_MESSAGE "module required but couldn't be found")
endif()

if(NOT CHECK_MODULES OR NOT ALSA_REQUIRED EQUAL -1)
    find_package(ALSA)
    if(TARGET ALSA::ALSA)
        list(APPEND OUTPUT_MODULES alsa)
    elseif(CHECK_MODULES AND NOT ALSA_REQUIRED EQUAL -1)
        message(FATAL_ERROR "alsa ${MODULE_NOT_FOUND_MESSAGE}")
    endif()
endif()

if(NOT CHECK_MODULES OR NOT COREAUDIO_REQUIRED EQUAL -1)
    if(APPLE)
        find_library(AUDIO_TOOLBOX AudioToolbox)
        list(APPEND OUTPUT_MODULES coreaudio)
    elseif(CHECK_MODULES AND NOT COREAUDIO_REQUIRED EQUAL -1)
        message(FATAL_ERROR "coreaudio ${MODULE_NOT_FOUND_MESSAGE}")
    endif()
endif()

find_package(PkgConfig)
if(PKG_CONFIG_FOUND)
    if(NOT CHECK_MODULES OR NOT PULSE_REQUIRED EQUAL -1)
        pkg_search_module(PULSE libpulse-simple)
        if(PULSE_FOUND)
            list(APPEND OUTPUT_MODULES pulse)
        elseif(CHECK_MODULES AND NOT PULSE_REQUIRED EQUAL -1)
            message(FATAL_ERROR "pulse ${MODULE_NOT_FOUND_MESSAGE}")
        endif()
    endif()
endif()

if(NOT CHECK_MODULES OR NOT WIN32_REQUIRED EQUAL -1)
    if(HAVE_WINDOWS_H)
        set(WIN32_LIBRARIES winmm)
        list(APPEND OUTPUT_MODULES win32)
    elseif(CHECK_MODULES AND NOT WIN32_REQUIRED EQUAL -1)
        message(FATAL_ERROR "win32 ${MODULE_NOT_FOUND_MESSAGE}")
    endif()
endif()

if(NOT CHECK_MODULES OR NOT WIN32_WASAPI_REQUIRED EQUAL -1)
    set(WASAPI_INCLUDES "initguid.h" "audioclient.h" "mmdeviceapi.h" "avrt.h")
    check_include_files("${WASAPI_INCLUDES}" HAVE_WASAPI)
    if(HAVE_WASAPI)
        set(WIN32_WASAPI_LIBRARIES ole32 avrt)
        list(APPEND OUTPUT_MODULES win32_wasapi)
    elseif(CHECK_MODULES AND NOT WIN32_WASAPI_REQUIRED EQUAL -1)
        message(FATAL_ERROR "win32_wasapi ${MODULE_NOT_FOUND_MESSAGE}")
    endif()
endif()

if(CHECK_MODULES)
    list(REMOVE_AT CHECK_MODULES
        ALSA_REQUIRED
        COREAUDIO_REQUIRED
        PULSE_REQUIRED
        WIN32_REQUIRED
        WIN32_WASAPI_REQUIRED)
    list(LENGTH CHECK_MODULES CHECK_MODULES_LENGTH)
    if(NOT CHECK_MODULES_LENGTH EQUAL 0)
        message(FATAL_ERROR "Dunno how to find modules: ${CHECK_MODULES}")
    endif()
endif()

if(NOT OUTPUT_MODULES)
    set(DEFAULT_OUTPUT_MODULE dummy)
    set(DEFAULT_OUTPUT_MODULES ${DEFAULT_OUTPUT_MODULE})
else()
    list(GET OUTPUT_MODULES 0 _DEFAULT_OUTPUT_MODULE)
    set(DEFAULT_OUTPUT_MODULE ${_DEFAULT_OUTPUT_MODULE} CACHE STRING "Default output module")
    if(BUILD_SHARED_LIBS)
        string(REPLACE ";" "," DEFAULT_OUTPUT_MODULES "${OUTPUT_MODULES}")
    else()
        set(DEFAULT_OUTPUT_MODULES ${DEFAULT_OUTPUT_MODULE})
    endif()
    set_property(CACHE DEFAULT_OUTPUT_MODULE PROPERTY STRINGS ${OUTPUT_MODULES})
endif()

option(ACCURATE_ROUNDING "use rounding instead of fast truncation for integer output, where possible" ON)
cmake_dependent_option(FIFO "FIFO support for control interface" ON "HAVE_MKFIFO" OFF)
option(GAPLESS "enable gapless" ON)
option(IEEE_FLOAT "use special hackery relying on IEEE 754 floating point storage format (to accurately round to 16 bit integer at bit more efficiently in generic decoder, enabled by default, disable in case you have a very special computer)" ON)
cmake_dependent_option(IPV6 "IPv6 support (actually any protocol your libc does with getaddrinfo)" ON "HAVE_IPV6" OFF)
if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
    option(NAGGING "turn on GCC's pedantic nagging with error on warnings" OFF)
    if(NAGGING)
        set(CMAKE_C_STANDARD 99)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror -pedantic")
    endif()
endif()
cmake_dependent_option(NETWORK "network support (http streams / webradio)" ON "HAVE_NETWORK" OFF)
option(NEWOLD_WRITE_SAMPLE "enable new/old WRITE_SAMPLE macro for non-accurate 16 bit output, faster on certain CPUs (default on on x86-32)" OFF)
cmake_dependent_option(NO_BUFFER "enable audio buffer code (default uses system whitelist... proper checks later)" OFF "HAVE_MMAP OR HAVE_SYS_IPC_H AND HAVE_SYS_SHM_H AND HAVE_SHMGET AND HAVE_SHMAT AND HAVE_SHMDT AND HAVE_SHMCTL" ON)
option(NO_DOWNSAMPLE "no downsampled decoding" OFF)
option(NO_EQUALIZER "no equalizer support" OFF)
option(NO_FEEDER "no feeder decoding, no buffered readers" OFF)
if(CYGWIN)
    option(NO_LFS_ALIAS "disable alias wrappers for largefile bitness (mpg123_seek_32 or mpg123_seek_64 in addition to mpg123_seek, or the other way around; It is a mess, do not play with this!)" ON)
else()
    option(NO_LFS_ALIAS "disable alias wrappers for largefile bitness (mpg123_seek_32 or mpg123_seek_64 in addition to mpg123_seek, or the other way around; It is a mess, do not play with this!)" OFF)
endif()
option(NO_ICY "ICY metainfo parsing/conversion" OFF)
option(NO_LAYER1 "no layer I decoding" OFF)
option(NO_LAYER2 "no layer II decoding" OFF)
option(NO_LAYER3 "no layer III decoding" OFF)
option(NO_MESSAGES "no error/warning messages on the console" OFF)
option(NO_MOREINFO "no extra information for frame analyzers" OFF)
option(NO_NTOM "no flexible resampling" OFF)
option(NO_16BIT "no 16 bit integer output" OFF)
option(NO_32BIT "no 32 bit integer output (also 24 bit)" OFF)
cmake_dependent_option(NO_8BIT "no 8 bit integer output" OFF "NOT NO_16BIT" ON)
option(NO_REAL "no real (floating point) output" OFF)
option(NO_STRING "no string API (this will disable ID3v2; main mpg123 won't build anymore)" OFF)
cmake_dependent_option(NO_ID3V2 "no ID3v2 parsing" OFF "NOT NO_STRING" ON)
option(SYN123_NO_CASES "include special cases for likely parameter values (channel count, encoding sizes in libsyn123 routines) in the hope of better optimization at the expense of some code bloat (default enabled)" OFF)
cmake_dependent_option(USE_MODULES "dynamically loadable output modules" ON "BUILD_SHARED_LIBS;HAVE_WIN_DL OR HAVE_UNIX_DL" OFF)
option(USE_NEW_HUFFTABLE "use new huffman decoding scheme by Taihei (faster on modern CPUs at least, so on by default)" ON)

configure_file(config.cmake.h.in config.h)

include_directories(
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../src/"
    "${CMAKE_CURRENT_BINARY_DIR}"

=== ports/cmake/src/libmpg123/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

option(NO_FEATURE_REPORT "Disable feature report function" OFF)
option(NO_LFS_ALIAS "disable alias wrappers for largefile bitness (mpg123_seek_32 or mpg123_seek_64 in addition to mpg123_seek, or the other way around; It is a mess, do not play with this!)" OFF)

include_directories("${CMAKE_CURRENT_BINARY_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/")

if(HAVE_STDLIB_H)
    set(INCLUDE_STDLIB_H "#include <stdlib.h>")
else()
    set(INCLUDE_STDLIB_H "/* #include <stdlib.h> is not available on this system */")
endif()
if(HAVE_SYS_TYPES_H)
    set(INCLUDE_SYS_TYPE_H "#include <sys/types.h>")
else()
    set(INCLUDE_SYS_TYPE_H "/* #include <sys/types.h> is not available on this system */")
endif()

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/mpg123.h.in" mpg123.h)

set(TARGET lib${PROJECT_NAME})
add_library(${TARGET}
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/parse.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/frame.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/format.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/dct64.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/equalizer.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/id3.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/optimize.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/readers.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/tabinit.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/libmpg123.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/index.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<NOT:$<BOOL:${NO_ICY}>>:icy.c>"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<NOT:$<BOOL:${NO_ICY}>>:icy2utf8.c>"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<NOT:$<BOOL:${NO_LAYER1}>>:layer1.c>"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<NOT:$<OR:$<BOOL:${NO_LAYER1}>,$<BOOL:${NO_LAYER2}>>>:layer2.c>"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<NOT:$<BOOL:${NO_LAYER3}>>:layer3.c>"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<NOT:$<BOOL:${NO_LFS_ALIAS}>>:lfs_alias.c>"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<NOT:$<BOOL:${NO_NTOM}>>:ntom.c>"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<NOT:$<BOOL:${NO_8BIT}>>:synth_8bit.c>"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<NOT:$<BOOL:${NO_16BIT}>>:synth.c>"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<AND:$<BOOL:${HAVE_FPU}>,$<NOT:$<BOOL:${NO_32BIT}>>>:synth_s32.c>"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<AND:$<BOOL:${HAVE_FPU}>,$<NOT:$<BOOL:${NO_REAL}>>>:synth_real.c>"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<NOT:$<BOOL:${NO_STRING}>>:stringbuf.c>"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<NOT:$<BOOL:${NO_FEATURE_REPORT}>>:feature.c>"
    "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/$<$<BOOL:${LFS_SENSITIVE}>:lfs_wrap.c>"
    $<TARGET_OBJECTS:compat>)

if((MSVC AND CMAKE_GENERATOR_PLATFORM STREQUAL "x64") OR (NOT MSVC AND CMAKE_SYSTEM_PROCESSOR MATCHES "([xX]86_|AMD|amd)64"))
    if(HAVE_FPU)
        set(PLATFORM_DEFINITIONS OPT_MULTI OPT_X86_64 OPT_AVX OPT_GENERIC OPT_GENERIC_DITHER)
        set(PLATFORM_SOURCES
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/dct36_x86_64.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/dct64_x86_64_float.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_x86_64_float.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_x86_64_s32.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_stereo_x86_64_float.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_stereo_x86_64_s32.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/dct36_avx.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/dct64_avx_float.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_stereo_avx_float.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_stereo_avx_s32.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/getcpuflags_x86_64.S")
        target_sources(${TARGET} PRIVATE
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/dither.c")
        if(ACCURATE_ROUNDING)
            list(APPEND PLATFORM_SOURCES
                "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_x86_64_accurate.S"
                "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_stereo_x86_64_accurate.S"
                "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_stereo_avx_accurate.S")
        else()
            list(APPEND PLATFORM_SOURCES
                "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/dct64_x86_64.S"
                "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_x86_64.S"
                "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_stereo_x86_64.S"
                "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_stereo_avx.S"
                "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/dct64_avx.S")
        endif()
    else()
        set(PLATFORM_DEFINITIONS OPT_GENERIC)
    endif()
elseif((MSVC AND CMAKE_GENERATOR_PLATFORM MATCHES "|Win32") OR (NOT MSVC AND CMAKE_SYSTEM_PROCESSOR MATCHES "i.86"))
    if(TRUE)
        set(PLATFORM_DEFINITIONS OPT_I386)
        target_sources(${TARGET} PRIVATE
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/dct64_i386.c")
    endif()

    cmake_host_system_information(RESULT HAVE_SSE QUERY HAS_SSE)
    if(HAVE_SSE)
        set(PLATFORM_DEFINITIONS OPT_SSE)
        set(PLATFORM_SOURCES
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/tabinit_mmx.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/dct36_sse.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/dct64_sse_float.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_sse_float.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_stereo_sse_float.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_sse_s32.S"
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_stereo_sse_s32.S")
        if(ACCURATE_ROUNDING)
            list(APPEND PLATFORM_SOURCES
                "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_sse_accurate.S"
                "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_stereo_sse_accurate.S")
        else()
            list(APPEND PLATFORM_SOURCES
                "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/dct64_sse.S"
                "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/synth_sse.S")
        endif()
        target_sources(${TARGET} PRIVATE
            "${CMAKE_CURRENT_SOURCE_DIR}/../../../../src/libmpg123/dct64_i386.c")
    endif()
endif()

set_target_properties(${TARGET} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})

target_compile_definitions(${TARGET} PRIVATE
    ${PLATFORM_DEFINITIONS}
    $<$<BOOL:${HAVE_FPU}>:REAL_IS_FLOAT>
    $<$<NOT:$<BOOL:${HAVE_FPU}>>:REAL_IS_FIXED>)

if(MSVC)
    find_program(YASM_ASSEMBLER yasm)
    if(NOT YASM_ASSEMBLER)
        message(FATAL_ERROR "Couldn't find yasm assembler. Please set YASM_ASSEMBLER variable")
    endif()
    if((MSVC AND CMAKE_GENERATOR_PLATFORM STREQUAL "x64") OR (NOT MSVC AND CMAKE_SYSTEM_PROCESSOR MATCHES "([xX]86_|AMD|amd)64"))
        set(MACHINE amd64)
    elseif((MSVC AND CMAKE_GENERATOR_PLATFORM MATCHES "|Win32") OR (NOT MSVC AND CMAKE_SYSTEM_PROCESSOR MATCHES "i.86"))
        set(MACHINE x86)
    endif()
    list(TRANSFORM PLATFORM_DEFINITIONS PREPEND /D)
    foreach(FILE ${PLATFORM_SOURCES})
        get_filename_component(FILENAME ${FILE} NAME)
        add_custom_command(
            OUTPUT ${FILENAME}.asm
            COMMAND ${CMAKE_C_COMPILER} /DASMALIGN_BALIGN ${PLATFORM_DEFINITIONS}
            /I"${PROJECT_SOURCE_DIR}/../../src" /I"${PROJECT_BINARY_DIR}/src" /P /Fi${FILENAME}.asm /Tc "${FILE}"
            DEPENDS ${FILE}
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
        add_custom_command(
            OUTPUT ${FILENAME}.obj
            COMMAND ${YASM_ASSEMBLER} -a x86 -m ${MACHINE} -p gas -r raw -f win32 -g null -o ${FILENAME}.obj ${FILENAME}.asm
            DEPENDS ${FILENAME}.asm
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
        target_sources(${TARGET} PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/${FILENAME}.obj")
    endforeach()
else()
    target_sources(${TARGET} PRIVATE ${PLATFORM_SOURCES})
endif()

if(BUILD_SHARED_LIBS)
    target_compile_definitions(${TARGET}
        PRIVATE $<$<BOOL:${WIN32}>:BUILD_MPG123_DLL>
        INTERFACE $<$<BOOL:${WIN32}>:LINK_MPG123_DLL>)
endif()

target_link_libraries(${TARGET} PRIVATE
    $<$<BOOL:${HAVE_M}>:m>
    $<$<BOOL:${WANT_WIN32_UNICODE}>:shlwapi>)
target_include_directories(${TARGET} INTERFACE
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")

install(TARGETS ${TARGET} EXPORT targets
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}/"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}/"
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}/")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/mpg123.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

=== debian/changelog ===
mpg123 (1.26.3-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 19 Jul 2020 11:09:35 +0200

mpg123 (1.26.2-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - Fix MA: same issues in libsyn123-dev (Closes: #963205)
  * debian/libsyn123.symbols: Add missing symbols for 32 bit architectures

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 05 Jul 2020 11:29:40 +0200

mpg123 (1.26.1-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 19 Jun 2020 23:19:16 +0200

mpg123 (1.26.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * debian/control: Bump Standards-Version
  * debian/:
    - Add new symboly
    - Add new libsyn123-0 package
    - Bump debhelper compat to 13
  * debian/rules: Remove -Wl,--as-needed
  * debian/copyright: Bump copyright years

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 26 May 2020 20:08:07 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: mpg123
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Reinhard Tartler <siretart@tauware.de>,
  Miguel A. Colón Vélez <debian.micove@gmail.com>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dpkg-dev (>= 1.18),
  libasound2-dev [linux-any],
  libaudio-dev,
@@ -17,7 +16,7 @@
  libpulse-dev [!hurd-i386],
  pkg-config,
  portaudio19-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: http://mpg123.org/
 Vcs-Git: https://salsa.debian.org/multimedia-team/mpg123.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/mpg123
@@ -78,6 +77,19 @@
  .
  This package contains the shared out123 library.
 
+Package: libsyn123-0
+Multi-Arch: same
+Architecture: any
+Section: libs
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends}
+Description: MPEG layer 1/2/3 audio decoder (libsyn123 shared library)
+ mpg123 is a real time MPEG 1.0/2.0/2.5 audio player/decoder for layers
+ 1, 2 and 3 (MPEG 1.0 layer 3 also known as MP3).
+ .
+ This package contains the shared syn123 library.
+
 Package: libmpg123-dev
 Multi-Arch: same
 Architecture: any
@@ -85,6 +97,7 @@
 Depends:
  libmpg123-0 (= ${binary:Version}),
  libout123-0 (= ${binary:Version}),
+ libsyn123-0 (= ${binary:Version}),
  ${misc:Depends}
 Description: MPEG layer 1/2/3 audio decoder (development files)
  mpg123 is a real time MPEG 1.0/2.0/2.5 audio player/decoder for layers
